unit uReferenciaMonitorGraficoSimple;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  uReferenciaMonitor, uMonitorGraficoSimple, uCosa, uVarDefs,
  Classes, SysUtils, uMonitores, Graphics, Forms, uCosaConNombre,
  xMatDefs;

resourcestring
  rsMonitorGraficoSimple = 'Monitor Gráfico Simple';
  mesEnElMonitor = 'En el monitor ';

type
  TReferenciaSerie = class(TReferenciaDefVar)
  public
    nombreSerie: string;
    color: TColor;

    constructor Create(capa: integer; xnombreSerie: string;
      xnombreCosa, xclaseCosa, xnombreVar: string; xcolor: TColor);
    constructor Create_ReadFromText(f: TArchiTexto); override;
    procedure WriteToText(f: TArchiTexto); override;
  end;

  TReferenciaMonGrafico = class(TReferenciaMonMultiVar)
  private
  public
    nombreGrafico: string;
    MaxNPuntos: integer;
    nombre_sx: string;
    etiquetax, etiquetay: string;
    x1, x2, y1, y2: NReal;
    NDivisionesX, NDivisionesY: integer;
    XIni: integer;
    diffX: integer;
    grilla: boolean;

    constructor Create(capa: integer; xnombreMon: string;
      xEventosProcs: TDAOfEventoProc; xnombreGrafico: string;
  xMaxNPuntos: integer; xnombre_sx: string; xetiquetax, xetiquetay: string;
  x1_, x2_, y1_, y2_: double; xNDivisionesX, xNDivisionesY: integer;
  xXIni: integer; xdiffX: integer; seriesy: TListaDeCosas; xgrilla: boolean);

    constructor Create_ReadFromText(f: TArchiTexto); override;
    procedure WriteToText(f: TArchiTexto); override;
    class function DescClase: string; override;

    procedure crearMonitorDeVariables(cosasMonitoreables: TListaDeCosasConNombre);
      override;
    class function tiposMonitoreables: AOfVarDef; override;
  end;

procedure AlInicio;
procedure AlFinal;

implementation

var
  VarDefsValidas_TMonGraficoSimple: AOfVarDef;

//---------------------------
//Metodos de TReferenciaSerie
//===========================

constructor TReferenciaSerie.Create(capa: integer; xnombreSerie: string;
  xnombreCosa, xclaseCosa, xnombreVar: string; {indice : Integer;}
  xcolor: TColor);
begin
  inherited Create(capa, xnombreCosa, xclaseCosa, xnombreVar{, indice});
  nombreSerie := xnombreSerie;
  color := xcolor;
end;

constructor TReferenciaSerie.Create_ReadFromText(f: TArchiTexto);
var
  rgbx: longint;
begin
  inherited Create_ReadFromText(f);
  f.IniciarLecturaRetrasada;
  f.rd('nombreSerie', nombreSerie);
  f.rd('color', rgbx);
  f.EjecutarLectura;
  color := TColor(rgbx);
end;

procedure TReferenciaSerie.WriteToText(f: TARchiTexto);
begin
  inherited WriteToText(f);
  f.wr('nombreSerie', nombreSerie);
  f.wr('color', Ord(color));
end;

//--------------------------------
//Metodos de TReferenciaMonGrafico
//================================

constructor TReferenciaMonGrafico.Create(capa: integer; xnombreMon: string;
  xEventosProcs: TDAOfEventoProc; xnombreGrafico: string;
  xMaxNPuntos: integer; xnombre_sx: string;
  xetiquetax, xetiquetay: string; x1_, x2_, y1_, y2_: double;
  xNDivisionesX, xNDivisionesY: integer; xXIni: integer;
  xdiffX: integer; seriesy: TListaDeCosas{of TReferenciaSerie};
  xgrilla: boolean);
begin
  inherited Create(capa, xnombreMon, xEventosProcs, seriesy);
  nombreGrafico := xnombreGrafico;
  MaxNPuntos := xMaxNPuntos;
  nombre_sx := xnombre_sx;
  etiquetax := xetiquetax;
  etiquetay := xetiquetay;
  x1 := x1_;
  x2 := x2_;
  y1 := y1_;
  y2 := y2_;
  NDivisionesX := xNDivisionesX;
  NDivisionesY := xNDivisionesY;
  XIni := xXIni;
  diffX := xdiffX;
  grilla := xgrilla;
end;

constructor TReferenciaMonGrafico.Create_ReadFromText(f: TArchiTexto);
begin
  inherited Create_ReadFromText(f);
  f.IniciarLecturaRetrasada;
  f.rd('nombreGrafico', nombreGrafico);
  f.rd('MaxNPuntos', MaxNPuntos);
  f.rd('nombre_sx', nombre_sx);
  f.rd('etiquetax', etiquetax);
  f.rd('etiquetay', etiquetay);
  f.rd('x1', x1);
  f.rd('x2', x2);
  f.rd('y1', y1);
  f.rd('y2', y2);
  f.rd('NDivisionesX', NDivisionesX);
  f.rd('NDivisionesY', NDivisionesY);
  f.rd('XIni', XIni);
  f.rd('diffX', diffX);
  f.rd('grilla', grilla);
  f.EjecutarLectura;
end;

procedure TReferenciaMonGrafico.WriteToText(f: TArchiTexto);
begin
  inherited WriteToText(f);
  f.wr('nombreGrafico', nombreGrafico);
  f.wr('MaxNPuntos', MaxNPuntos);
  f.wr('nombre_sx', nombre_sx);
  f.wr('etiquetax', etiquetax);
  f.wr('etiquetay', etiquetay);
  f.wr('x1', x1);
  f.wr('x2', x2);
  f.wr('y1', y1);
  f.wr('y2', y2);
  f.wr('NDivisionesX', NDivisionesX);
  f.wr('NDivisionesY', NDivisionesY);
  f.wr('XIni', XIni);
  f.wr('diffX', diffX);
  f.wr('grilla', grilla);
end;

class function TReferenciaMonGrafico.DescClase: string;
begin
  Result := rsMonitorGraficoSimple;
end;

procedure TReferenciaMonGrafico.crearMonitorDeVariables(
  cosasMonitoreables: TListaDeCosasConNombre);
var
  listaDescSeries: TList;
  i: integer;
  varDef: TVarDef;
  serie: TDescSerie;
  refSerie: TReferenciaSerie;
  errores: string;
begin
  errores := '';
  listaDescSeries := TList.Create;
  for i := 0 to defVars.Count - 1 do
  begin
    try
      begin
        refSerie := TReferenciaSerie(defVars[i]);
        varDef := refSerie.resolver(cosasMonitoreables);
        varDef.Prepararse;
        serie := TDescSerie.Create(refSerie.nombreSerie, refSerie.color, varDef);
        listaDescSeries.Add(serie);
      end
    except
      on E: EReferenciaDefVarException do
        errores := errores + E.Message;
    end;
  end;
  i := listaDescSeries.Count;
  if listaDescSeries.Count <> 0 then
    monitor := TMonGraficoSimple.Create(Application.MainForm, nombreGrafico,
      MaxNPuntos, nombre_sx, etiquetax, etiquetay, x1, x2,
      y1, y2, NDivisionesX, NDivisionesY, XIni, diffX,
      listaDescSeries, grilla, posEnSala);
  if errores <> '' then
    raise EMonitorException.Create(errores + mesEnElMonitor + nombre + '.', i);
end;

class function TReferenciaMonGrafico.tiposMonitoreables: AOfVarDef;
begin
  Result := VarDefsValidas_TMonGraficoSimple;
end;

procedure AlInicio;
begin
  registrarClaseDeCosa(TReferenciaMonGrafico.ClassName, TReferenciaMonGrafico);
  registrarClaseDeCosa(TReferenciaSerie.ClassName, TReferenciaSerie);

  SetLength(VarDefsValidas_TMonGraficoSimple, 3);
  VarDefsValidas_TMonGraficoSimple[0] := TVarDef_NR;
  VarDefsValidas_TMonGraficoSimple[1] := TVarDef_NI;
  VarDefsValidas_TMonGraficoSimple[2] := TVarDef_B;
end;

procedure AlFinal;
begin
  SetLength(VarDefsValidas_TMonGraficoSimple, 0);
end;

end.
